#!/usr/bin/env python
# coding: utf-8

# In[1]:


import gpxpy
import gpxpy.gpx
import math as mt
import pygal
import cairosvg


# In[2]:


#apre il file inserendo il nome tipo stringa da input tastiera
nome_file = '2020-05-31_08-50-43_giro'
gpx_file = open('{0}.gpx'.format(nome_file), 'r') 

gpx = gpxpy.parse(gpx_file)

#crea una lista per ogni dato
time = []
for track in gpx.tracks:
    for segment in track.segments:
        for point in segment.points:
            time.append(point.time)

latitude = []
for track in gpx.tracks:
    for segment in track.segments:
        for point in segment.points:
            latitude.append(point.latitude)

longitude = []
for track in gpx.tracks:
    for segment in track.segments:
        for point in segment.points:
            longitude.append(point.longitude)

elevation = []
for track in gpx.tracks:
    for segment in track.segments:
        for point in segment.points:
            elevation.append(point.elevation)

track_points = dict()
track_points['time'] = time
track_points['latitude'] = latitude
track_points['longitude'] = longitude
track_points['elevation'] = elevation

i = 0
track_points['r'] = []

while i < len(track_points['time']):
    
    track_points['r'].append(track_points['elevation'][i] + 6371000)
    
    i = i + 1

i = 0
track_points['x'] = []
track_points['y'] = []
track_points['z'] = []


while i < len(track_points['time']):
    
 
    track_points['x'].append(track_points['r'][i] * mt.cos(track_points['longitude'][i]*mt.pi/180) * mt.cos(track_points['latitude'][i]*mt.pi/180))

    track_points['y'].append(track_points['r'][i] * mt.sin(track_points['longitude'][i]*mt.pi/180) * mt.cos(track_points['latitude'][i]*mt.pi/180))

    track_points['z'].append(track_points['r'][i] * mt.sin(track_points['latitude'][i]*mt.pi/180))
      
    i = i + 1
    
track_points['dist_parz'] = []
track_points['dist_parz'].append(0)
track_points['delta_t'] = []
track_points['delta_t'].append(0)

i = 0

while i < ( len(track_points['time'])-1 ): #la lunghezza della lista track_points['dist_parz'] conta un elemento in meno rispetto a quelle viste fino a qui
    track_points['dist_parz'].append(mt.sqrt(mt.pow( (track_points['x'][i+1] - track_points['x'][i]) ,2) + mt.pow( (track_points['y'][i+1] - track_points['y'][i]) ,2)+mt.pow( (track_points['z'][i+1] - track_points['z'][i]) ,2)))
    track_points['delta_t'].append(track_points['time'][i+1] - track_points['time'][i])
    i = i + 1

i = 0
track_points['progressive_t'] = []
track_points['progressive_dist'] = []
track_points['average_vel'] = []
track_points['average_vel'].append(0)
progressive_dist = 0 

while i <  len(track_points['time']):

    track_points['progressive_t'].append( (track_points['time'][i] - track_points['time'][0]).total_seconds() )
    
    progressive_dist = progressive_dist + track_points['dist_parz'][i]
    track_points['progressive_dist'].append(progressive_dist)
    
    i = i + 1
    
i = 1

while i <  len(track_points['time']):
    track_points['average_vel'].append( track_points['dist_parz'][i] / ( track_points['delta_t'][i].total_seconds() ) * 3.6 )
    i = i + 1
    
i = 1
#track_points['average_vel'].append(track_points['average_vel'][i-2])


# In[3]:


approx_longitude = []
i = 0
while i < ( len(longitude) ):
        
    approx_longitude.append(round(longitude[i],5))
    
    i = i+1

index_start = approx_longitude.index(11.05435)
index_end = approx_longitude.index(11.06479)


# In[4]:


time_1 = time[index_start:index_end+1]
longitude_1 = longitude[index_start:index_end+1]
latitude_1 = latitude[index_start:index_end+1]
elevation_1 = elevation[index_start:index_end+1]

track_points_1 = dict()
track_points_1['time'] = time_1
track_points_1['latitude'] = latitude_1
track_points_1['longitude'] = longitude_1
track_points_1['elevation'] = elevation_1

i = 0
track_points_1['r'] = []

while i < len(track_points_1['time']):
    
    track_points_1['r'].append(track_points_1['elevation'][i] + 6371000)
    
    i = i + 1

i = 0
track_points_1['x'] = []
track_points_1['y'] = []
track_points_1['z'] = []


while i < len(track_points_1['time']):
    
 
    track_points_1['x'].append(track_points_1['r'][i] * mt.cos(track_points_1['longitude'][i]*mt.pi/180) * mt.cos(track_points_1['latitude'][i]*mt.pi/180))

    track_points_1['y'].append(track_points_1['r'][i] * mt.sin(track_points_1['longitude'][i]*mt.pi/180) * mt.cos(track_points_1['latitude'][i]*mt.pi/180))

    track_points_1['z'].append(track_points_1['r'][i] * mt.sin(track_points_1['latitude'][i]*mt.pi/180))
      
    i = i + 1
    
track_points_1['dist_parz'] = []
track_points_1['dist_parz'].append(0)
track_points_1['delta_t'] = []
track_points_1['delta_t'].append(0)

i = 0

while i < ( len(track_points_1['time'])-1 ): #la lunghezza della lista track_points_1['dist_parz'] conta un elemento in meno rispetto a quelle viste fino a qui
    track_points_1['dist_parz'].append(mt.sqrt(mt.pow( (track_points_1['x'][i+1] - track_points_1['x'][i]) ,2) + mt.pow( (track_points_1['y'][i+1] - track_points_1['y'][i]) ,2)+mt.pow( (track_points_1['z'][i+1] - track_points_1['z'][i]) ,2)))
    track_points_1['delta_t'].append(track_points_1['time'][i+1] - track_points_1['time'][i])
    i = i + 1

i = 0
track_points_1['progressive_t'] = []
track_points_1['progressive_dist'] = []
track_points_1['average_vel'] = []
track_points_1['average_vel'].append(0)
progressive_dist = 0 

while i <  len(track_points_1['time']):

    track_points_1['progressive_t'].append( (track_points_1['time'][i] - track_points_1['time'][0]).total_seconds() )
    
    progressive_dist = progressive_dist + track_points_1['dist_parz'][i]
    track_points_1['progressive_dist'].append(progressive_dist)
    
    i = i + 1
    
i = 1

while i <  len(track_points_1['time']):
    track_points_1['average_vel'].append( track_points_1['dist_parz'][i] / ( track_points_1['delta_t'][i].total_seconds() ) * 3.6 )
    i = i + 1
    


# In[5]:


i = 0
discretizza_progressive_dist_1 = []
discretizza_elevation_1 = []
discretizza_average_vel_1 = []
discretizza_progressive_t_1 = []
while i < ( len(track_points_1['time'])-1 ):
    discretizza_progressive_dist_1.append(track_points_1['progressive_dist'][i])
    discretizza_elevation_1.append(track_points_1['elevation'][i])
    discretizza_average_vel_1.append(track_points_1['average_vel'][i])
    discretizza_progressive_t_1.append(track_points_1['progressive_t'][i])
    i = i+50
    
i = 1
while i < ( len(discretizza_progressive_dist_1) ):
        
    discretizza_progressive_dist_1[i] = round(discretizza_progressive_dist_1[i],2)
    
    i = i+1


# In[6]:


from pygal.style import DarkSolarizedStyle
line_chart = pygal.StackedLine(fill=True,
                               show_legend=False, 
                               style=DarkSolarizedStyle, 
                               x_label_rotation=90, 
                               x_title= 'distanza progressiva [m]', 
                               y_title = 'altitudine [m]')
line_chart.title = 'dislivello'
line_chart.x_labels = discretizza_progressive_dist_1
line_chart.add('Elevation', discretizza_elevation_1)
line_chart.fill = True
line_chart.human_readable = True
line_chart.render_in_browser()
line_chart.render_to_png('budda-faggio_dislivello.png')


# In[7]:


from pygal.style import CleanStyle
line_chart = pygal.StackedLine(fill=True, 
                               show_legend=False,
                               style=CleanStyle,
                               x_label_rotation=90,
                               x_title= 'tempo [s]',
                               y_title = 'spazio [m]',
                               label_font_size = 500)
#line_chart = pygal.Line()
line_chart.title = 'legge oraria'
line_chart.x_labels = discretizza_progressive_t_1
#line_chart.x_value_formatter = lambda x:  '%.0f'% x
#line_chart.show_x_labels = False
line_chart.add('distanza percorsa [m]', discretizza_progressive_dist_1)
line_chart.fill = True
line_chart.human_readable = True
line_chart.render_in_browser()
#line_chart.render_to_file('chart.svg')
line_chart.render_to_png('budda-faggio_legge oraria.png')


# In[8]:


from pygal.style import TurquoiseStyle
line_chart = pygal.StackedLine(fill=True,
                               show_legend=False,
                               style=TurquoiseStyle,
                               x_label_rotation=90, x_title= 't [s]',
                               y_title = 'v [km/h]')
#line_chart = pygal.Line()
line_chart.title = 'v(t)'
line_chart.x_labels = discretizza_progressive_t_1
#line_chart.x_value_formatter = lambda x:  '%.0f'% x
#line_chart.show_x_labels = False
line_chart.add('Elevation', discretizza_average_vel_1)
line_chart.fill = True
line_chart.human_readable = True
line_chart.render_in_browser()
#line_chart.render_to_file('chart.svg')
line_chart.render_to_png('budda-faggio_velocità tempo.png')

